/*
 * Nenad Taskovic 5/93
 * e-mail: neyt@fon.bg.ac.yu
 * www: http://fon.fon.bg.ac.yu/~neyt/
 */

#include <conio.h>
#include <values.h>
#include <stdlib.h>

#define X_POM	3
#define Y_POM	3

#define crUP      18432
#define crLEFT    19200
#define crRIGHT   19712
#define crCTL_LEFT   29440
#define crCTL_RIGHT  29696
#define crCTL_ENTER  10

struct Cvor_struct {
   int pod;
   struct Cvor_struct *levo, *desno, *roditelj;
};

typedef struct Cvor_struct Cvor;

Cvor *koren = NULL, *tekuci = NULL;

static int najmanji, najveci;

void testiraj_rek (Cvor *tek, int nivo)
{
   if (tek->levo == NULL && tek->desno == NULL) {
      if (nivo > najveci)
         najveci = nivo;
      if (nivo < najmanji)
         najmanji = nivo;
   }
   else {
      if (tek->levo != NULL)
         testiraj_rek(tek->levo, nivo+1);
      if (tek->desno != NULL)
         testiraj_rek(tek->desno, nivo+1);
   }
}

int testiraj_balans (void)
{
   najmanji = 32000;
   najveci = 0;
   testiraj_rek(koren, 0);
   return ((najveci - najmanji) <= 1);
}

int najveci_u_stablu (Cvor *tek)
{
   if (tek == NULL)
      return -MAXINT;
   else
      return max(max(najveci_u_stablu(tek->levo), tek->pod), najveci_u_stablu(tek->desno));
}

int najmanji_u_stablu (Cvor *tek)
{
   if (tek == NULL)
      return MAXINT;
   else
      return min(min(najmanji_u_stablu(tek->levo), tek->pod), najmanji_u_stablu(tek->desno));
}

int testiraj_bst (Cvor *tek)
{
   if (tek == NULL)
      return 1;
   else {
      if (!testiraj_bst(tek->levo))
         return 0;
      if (!testiraj_bst(tek->desno))
         return 0;
      if (najveci_u_stablu(tek->levo) > tek->pod)
         return 0;
      if (najmanji_u_stablu(tek->desno) < tek->pod)
         return 0;
      return 1;
   }
}

void testiraj_avl (void)
{
   gotoxy(1, 25);
   if (testiraj_balans() && testiraj_bst(koren))
      cprintf("Stablo je AVL.");
   else
      cprintf("Stablo nije AVL.");
}

Cvor *alociraj_cvor (int podatak)
{
   Cvor *pok;
   pok = (Cvor *) malloc(sizeof(Cvor));
   pok->levo = pok->desno = pok->roditelj = NULL;
	pok->pod = podatak;

	return pok;
}

void ubaci_koren (int podatak)
{
	if (koren == NULL) {
		koren = alociraj_cvor(podatak);
		tekuci = koren;
   }
}

void ubaci_levo (int podatak)
{
   if (tekuci->levo == NULL) {
      tekuci->levo = alociraj_cvor(podatak);
		tekuci->levo->roditelj = tekuci;
   }
}

void ubaci_desno (int podatak)
{
   if (tekuci->desno == NULL) {
      tekuci->desno = alociraj_cvor(podatak);
      tekuci->desno->roditelj = tekuci;
   }
}

void tekuci_levo (void)
{
	if (tekuci->levo != NULL)
	  tekuci = tekuci->levo;
}

void tekuci_desno (void)
{
	if (tekuci->desno != NULL)
	  tekuci = tekuci->desno;
}

void tekuci_gore (void)
{
	if (tekuci->roditelj != NULL)
		tekuci = tekuci->roditelj;
}

int x_koord;

void nacrtaj_liniju (int x1, int y1, int x2, int y2)
{
   int n, i;
   if (x2 > x1) {
      n = x2 - x1;
      gotoxy(x1, y1);
      cprintf("");
      for (i=0; i<n; i++)
         cprintf("");
      n = y2 - y1 + 1;
      gotoxy(x2, y1);
      cprintf("");
      for (i=1; i<n; i++) {
         gotoxy(x2, y1+i);
         cprintf("");
      }
      gotoxy(x2, y1+n);
      cprintf("");
   }
   else {
      n = x1 - x2;
      gotoxy(x2, y1);
      cprintf("");
      for (i=1; i<n; i++)
         cprintf("");
      cprintf("");
      n = y2 - y1 + 1;
      for (i=1; i<n; i++) {
         gotoxy(x2, y1+i);
         cprintf("");
      }
      gotoxy(x2, y1+n);
      cprintf("");
   }
}

void nacrtaj_cvor (Cvor *tek, int nivo)
{
	x_koord += X_POM;
	gotoxy(x_koord, nivo*Y_POM+1);
	cprintf("Ŀ");
	gotoxy(x_koord, nivo*Y_POM+2);
   if (tek == tekuci) {
      cprintf(""); textattr(0x70); cprintf("%3d", tek->pod);
      textattr(0x07); cprintf("");
   }
   else
      cprintf("%3d", tek->pod);
	gotoxy(x_koord, nivo*Y_POM+3);
	cprintf("");
}

int crtaj_rek (Cvor *tek, int nivo)
{
   int pam1, pam2;
	if (tek != NULL) {
		pam1 = crtaj_rek(tek->levo, nivo+1);
		nacrtaj_cvor(tek, nivo);
      if (pam1 != 0)
         nacrtaj_liniju(x_koord, nivo*Y_POM+2, pam1+2, (nivo+1)*Y_POM);
      pam1 = x_koord;
		pam2 = crtaj_rek(tek->desno, nivo+1);
      if (pam2 != 0)
         nacrtaj_liniju(pam1+4, nivo*Y_POM+2, pam2+2, (nivo+1)*Y_POM);
      return pam1;
	}
   return 0;
}

void nacrtaj_drvo (void)
{
	x_koord = -X_POM+1;

	crtaj_rek(koren, 0);
}

int broj (void)
{
   int br;

   gotoxy(1, 25);
   cprintf("Unesite broj za novi cvor > ");
   cscanf(" %d", &br);

   return br;
}

void izbor (void)
{
   int c;
   do {
      c = getch();
      if (!c)
         c = 256*getch();
      switch (c) {
         case crUP:
            tekuci_gore();
            break;
         case crLEFT:
            tekuci_levo();
            break;
         case crRIGHT:
            tekuci_desno();
            break;
         case crCTL_LEFT:
            if (tekuci->levo == NULL)
               ubaci_levo(broj());
            break;
         case crCTL_RIGHT:
            if (tekuci->desno == NULL)
               ubaci_desno(broj());
            break;
         case crCTL_ENTER:
            testiraj_avl();
            break;
      }
      if (c == crCTL_RIGHT || c == crCTL_LEFT)
         clrscr();
      nacrtaj_drvo();
   } while (c != 27);
}

void main (void)
{
   clrscr();
   ubaci_koren(broj());
   clrscr();
   nacrtaj_drvo();
   izbor();
}

